function em=solve_for_ur
% SOLVE_FOR_UR.M solves for ur for given ul
% A SHOCK FITTING PRIMER - CHAPTER 2, "Boundary Shock-Fitting".
%
% Called by exactgauss.m
% Copyright 2005-2008 M.D.Salas.

global ur0 eps0 ul ur sqpi t gr gl

for k=1:10
    if k==1
        tu(1)=ur0;
        m=1;
    end
    if k==2
        tu(2)=ur0*.98;
        m=2;
    end
    if k>2
        tu3=tu(2)-e(2)*(tu(2)-tu(1))/(e(2)-e(1));
        tu(1)=tu(2);
        e(1)=e(2);
        tu(2)=tu3;
    end
    ur=tu(m);
    if ur < 0.
        ur = eps0;
        tu(m)= eps0;
    end
    gr=sqrt(-log(ur));
    gl=sqrt(-log(ul));
    if t > 1.7421
        e(m)=gl+gr-sqpi*(erf(gr)+erf(gl))/(ul+ur);
    else
        e(m)=gr-gl-sqpi*(erf(gr)-erf(gl))/(ul+ur);
    end
    if abs(e(m)) < eps0;
        break
    end
end
em=e(m);
if abs(e(m)) > eps0
    disp(['the error in "ur" iteration is: ', num2str(e(m)),...
        'at t= ', num2str(t)])
end