function find_shk_xing
% FIND_SHK_XING.M - detects shock crossing and resets dt
% A SHOCK FITTING PRIMER - CHAPTER 2, "Floating Shock-Fitting". 
%
% Copyright 2005-2008 M.D.Salas.

global eps0 dt FLAG kmax ICROSS kcross xs w

FLAG=0;
for k=2:kmax                                                                % check for shock crossing, reset dt if etest < 1
    ICROSS(k)=1/eps0;
    if w(k-1) > w(k)                                                        % no crossing if w(k-1) < w(k)
        etest=(xs(k-1)-xs(k))/(w(k)-w(k-1))/dt;                             % etest=(t*-t)/dt, number of dt's to crossing
        if (etest > 0) && (etest <= 1.1)
            ICROSS(k)=min([etest, 1]);                                      % set trigger on
            FLAG = 1;
        end
    end
end
if FLAG == 1
    [newdt, kcross]=min(ICROSS);                                            % of all possible crossings, in next t interval, choose the one occuring first
    dt=newdt*dt;
end