function plot_solution7(INDEX)
% PLOT_SOLUTION7.M creates plots
% A SHOCK FITTING PRIMER - CHAPTER 2, "Floating Shock-Fitting".
%
% Copyright 2005-2008 M.D.Salas.

global kout tout xsout N INIT nfig kmax x u xs usL usR t

tsdata=[1.1658 1.2 1.3 1.35 1.4 1.45 1.5 1.55 1.6 1.7421...
    1.8 2. 2.5 3. 3.5 4. 4.5 5.];
xsdata=[1.4142 1.4349 1.4943 1.5234 1.5523 1.5809 1.6091...
    1.6371 1.6648 1.7421 1.7730 1.8776 2.1256 2.3576 2.5765...
    2.7843 2.9825 3.1722];

if INDEX == 1
    nfig=nfig+1;
    figure(nfig)                                                            % initial u-profile

    nn=0;
    for n=1:N
        nn=nn+1;
        xplot(nn)=x(n);
        uplot(nn)=u(n);
        if kmax > 0
            for k=1:kmax
                if (x(n)-xs(k))*(x(n+1)-xs(k)) < 0
                    nn=nn+1;
                    xplot(nn)=xs(k);
                    uplot(nn)=usL(k);
                    nn=nn+1;
                    xplot(nn)=xs(k);
                    uplot(nn)=usR(k);
                end
            end
        end
    end

    plot(xplot,uplot,'k-o')
    xlabel('x')
    ylabel('u')
    f=['Initial Conditions, t=' num2str(t)];
    title(f)

else                                                                        % INDEX==2

    nn=0;
    for n=1:N
        nn=nn+1;
        xplot(nn)=x(n);
        uplot(nn)=u(n);
        if kmax > 0
            for k=1:kmax
                if (x(n)-xs(k))*(x(n+1)-xs(k)) < 0
                    nn=nn+1;
                    xplot(nn)=xs(k);
                    uplot(nn)=usL(k);
                    nn=nn+1;
                    xplot(nn)=xs(k);
                    uplot(nn)=usR(k);
                end
            end
        end
    end

    nfig=nfig+1;
    figure(nfig)
    plot(xplot,uplot,'k-')
    xlabel('x')
    ylabel('u')
    f=['u at t=' num2str(t)];
    title(f)

    if kmax > 0
        nfig=nfig+1;
        figure(nfig)
        if INIT == 5
            for n=1:kout
                xsp2(n)=xsout(2,n);
                tsp2(n)=tout(2,n);
            end
            plot(xsp2,tsp2,'k-')
            hold on
            for n=1:kout
                if xsout(3,n) < 4                                           % this is done to avoid plotting slope discontinuity at x=4
                    xsp3(n)=xsout(3,n);
                    tsp3(n)=tout(3,n);
                end
            end
            plot(xsp3,tsp3,'r+')
            hold off
            xlabel('x')
            ylabel('t')
            f='Shock Wave Paths';
            title(f)
        elseif INIT == 6
            for n=1:kout
                xsp1(n)=xsout(1,n);
                tsp1(n)=tout(1,n);
            end
            hold on
            plot(xsp1,tsp1,'k-')
            xlabel('x')
            ylabel('t')
            f='Shock Wave Paths';
            title(f)
            plot(xsout,tout,'k.')
        elseif INIT == 2
            for n=1:kout
                xsp2(n)=xsout(2,n);
                tsp2(n)=tout(2,n);
            end
            plot(xsp2,tsp2,'k-')
            xlabel('x')
            ylabel('t')
            f='Shock Wave Path';
            title(f)
        elseif INIT == 3 || INIT == 1 || INIT == 4 || INIT == 7
            nn=0;
            for n=1:kout
                if tout(1,n) > 0
                    nn=nn+1;
                    xsp2(nn)=xsout(1,n);
                    tsp2(nn)=tout(1,n);
                end
            end
            if INIT == 4
                plot(xsp2,tsp2,'ko',-xsdata,tsdata,'k-')
                legend('computed' ,'exact')
            elseif INIT == 3
                plot(xsp2,tsp2,'k-')
                legend('computed')
            else
                plot(xsp2,tsp2,'ko', xsdata,tsdata,'k-')
                legend('computed' ,'exact')
            end
            xlabel('x')
            ylabel('t')
            f='Shock Wave Path';
            title(f)
        elseif INIT == 8
            for n=1:kout
                xsp1(n)=xsout(1,n);
                tsp1(n)=tout(1,n);
            end
            hold on
            xtick=[.45 .55];
            ttick=[1/pi 1/pi];
            plot(xsp1,tsp1,'k.', xtick,ttick,'k-')
            xlabel('x')
            ylabel('t')
            f='Shock Wave Paths';
            title(f)
            plot(xsout,tout,'k.')
            xmin=.4;
            xmax=.6;
            xlim([xmin xmax])
        end
    end
end

