function shock_cross
% SHOCK_CROSS.M - re-orders shocks after crossing
% A SHOCK FITTING PRIMER - CHAPTER 2, "Floating Shock-Fitting".
%
% performs crossing of k-1 & k shocks, where k=kcross
%
% Copyright 2005-2008 M.D.Salas.
%
global kmax kcross xs w usL usR

km=kcross-1;

usR(km)=usR(kcross);
w(km)=.5*(usL(km)+usR(km));

if kcross ~= kmax                                                           % shift shock index to left by one
    for k=kcross:kmax-1
        usL(k)=usL(k+1);
        usR(k)=usR(k+1);
        w(k)=w(k+1);
        xs(k)=xs(k+1);
    end
end

kmax=kmax-1;
shock_index
