function shock_index
% SHOCK_INDEX.M - builds shock indexes I & IS
% A SHOCK FITTING PRIMER - CHAPTER 2, "Floating Shock-Fitting".
%
% Copyright 2005-2009 M.D.Salas.
%
global eps0 I IS N NT kmax x x_s

for n=1:NT
    I(n,1)=0;
    I(n,2)=0;
end
for k=1:kmax
    for n=1:N                                                               % locate shock & create shock index
        if (x(n)-x_s(k)) == 0
            x_s(k)=x_s(k)+eps0;                                             % done to avoid shock location overlapping mesh point location
        end
        if (x(n)-x_s(k))*(x(n+1)-x_s(k)) < 0                                % true if shock in cell [n,n+1]
            IS(k)=n;                                                        % store mesh point to left of k-th shock
            if I(n,1) == 0                                                  % true if this is the first shock in this cell
                I(n,1)=k;                                                   % then, define first shock in cell [n,n+1]
                I(n,2)=k;                                                   % and, in case this is the only shock, set last shock in cell to k
            else                                                            % if not first shock in cell
                I(n,2)=k;                                                   % define last shock in cell [n,n+1]
            end
        end
    end
end
