function exact
% A SHOCK FITTING PRIMER - CHAPTER 4, "Piston Driven Flows".
%
% exact solution to piston flow before shock formation
% 
% x & t given, find tau, u(x,t)=bt(tau)
% Copyright 2005-2008 M.D.Salas.

global t gamma uexact NT x X Pexact aexact sg gm

gp=gamma+1;
xbar=sg*t;                                                                  % location of first signal at t
b=pistonlaw(t);
c=exitboundary(t);

for n=1:NT
    x(n)=b+(c-b)*X(n);
    uexact(n)=0;
end
tau=t;
uexact(1)=pistonlawt(tau);
ae=sg+gm*uexact(1)/2;
aexact(1)=ae;
Ze=ae^2/gamma;
Pexact(1)=gamma*log(Ze)/gm;
for n=2:NT
    if x(n) < xbar
        for m=1:20
            B=pistonlaw(tau);
            Bt=pistonlawt(tau);
            Btt=pistonlawtt(tau);
            F=x(n)-(B+(sg+gp*Bt/2)*(t-tau));                               % Newton iteration
            Ftau=-(Bt+gp*Btt*(t-tau)/2-(sg+gp*Bt/2));
            taun=tau-F/Ftau;
            err=abs(taun-tau);
            if err < 10^-10
                break
            end
            tau=taun;
        end
        if err > 10^-10
            disp(['err= ' num2str(err) ' n= ' num2str(n)])
        end
        uexact(n)=pistonlawt(tau);
    end
    ae=sg+gm*uexact(n)/2;
    aexact(n)=ae;
    Ze=ae^2/gamma;
    Pexact(n)=gamma*log(Ze)/gm;   
end