% plots of area oscillation boundaries for cases 5-7
clear all

N=100;
NT=N+1;
dx=1/N;
b=0;
c=2;

nfig=1;
figure(nfig)
for n=1:NT
    X=(n-1)*dx;
    x(n)=b+(c-b)*X;   
end

    for n=1:NT
    area(n)=x(n)+1/(x(n));
    end
    plot(x,area,'k-')
    ylim([0,10])
    xlabel('x')
    ylabel('area')
    title('case 7:  area=x*(1+eps*sin(t))+1/x')
    hold on
    
    eps=.1;
    for n=1:NT
        area(n)=x(n)*(1+eps)+1/x(n);
    end
    plot(x,area,'k--')
    hold on
    eps=-.1;
    for n=1:NT
        area(n)=x(n)*(1+eps)+1/x(n);
    end
    plot(x,area,'k--')
    hold off
    
    nfig=nfig+1;
    figure(nfig)

    for n=1:NT
        area(n)=x(n)+1/x(n);
    end
    plot(x,area,'k-')
    ylim([0,10])
    xlabel('x')
    ylabel('area')
    title('case 6: area=x+eps*sin(t)+1/x')
    hold on
    
    eps=.5;
    for n=1:NT
        area(n)=x(n)+eps+1/x(n);
    end
    plot(x,area,'k--')
    hold on
    
    eps=-.5;
    for n=1:NT
        area(n)=x(n)+eps+1/x(n);
    end
    plot(x,area,'k--')
    hold off
    
    nfig=nfig+1;
    figure(nfig)
   
    for n=1:NT
        area(n)=x(n)+1/x(n);
    end
    plot(x,area,'k-')
    ylim([0,10])
    xlabel('x')
    ylabel('area')
    title('case 5: area=x+1/(x+eps*sin(t)^2)')
    hold on
    
    eps=.12;
    for n=1:NT
        area(n)=x(n)+1/(x(n)+eps);
    end
    plot(x,area,'k--')
    hold off
    
    nfig=nfig+1;
    figure(nfig)
   
    for n=1:NT
        area(n)=x(n)+1/x(n);
    end
    plot(x,area,'k-')
    ylim([0,10])
    xlabel('x')
    ylabel('area')
    title('case 8: area=x+1/x+sin(t)*e^-(x-1)^2')
    hold on
    
    eps=.2;
    for n=1:NT
        f=eps*exp(-30*(x(n)-1)^2);
        area(n)=x(n)+1/x(n)+f;
    end
    plot(x,area,'k--')
    hold on
    
    eps=-.2;
    for n=1:NT
        f=eps*exp(-30*(x(n)-1)^2);
        area(n)=x(n)+1/x(n)+f;
    end
    plot(x,area,'k--')
    hold off
    
    nfig=nfig+1;
    figure(nfig)
    b=0;
    c=3;
for n=1:NT
    X=(n-1)*dx;
    x(n)=b+(c-b)*X;   
end

    for n=1:NT
        if x(n) < 1
    area(n)=x(n)+1/x(n);
        elseif x(n) < 2
    area(n)=2+8*( ((x(n)-1)^2)*((x(n)-2)^2) );
        else
            area(n)=x(n)-1+1/(x(n)-1);
    end
    end
    plot(x,area,'k-')
    ylim([-10,10])
    xlabel('x')
    ylabel('area')
    title('case 8: double throat')
    grid on
    hold off
    
    

    
    
    
    
    
    