function areat=areat_f(x, t, area_index)
% AREA.M - defines d(area)/dt as a function of x for quasi-one-dimensional flows
% A SHOCK FITTING PRIMER - CHAPTER 4, "Piston Driven Flows".
%
% Copyright 2005-2008 M.D.Salas.

global osci_eps pulse_loc

switch area_index
    case 5
        t1=4;
        areat=1-(2.*osci_eps*pi/t1)*cos(pi*t/t1)*sin(pi*t/t1)/...
            (x+osci_eps*sin(pi*t/t1)^2)^2;      
    case 6
        eps1=.5;
        t1=4;
                                                                            % area=x+eps1*sin(pi*t/t1)+1/x;
        areat=eps1*(pi/t1)*cos(pi*t/t1);
    case 7
        eps1=.1;
        t1=.4;                                                              % area=x*(1+eps1*sin(pi*t/t1))+1/x;
        areat=x*eps1*pi*cos(pi*t/t1)/t1;
    case 8
        eps1=.2;
        t1=4;
        areat=pi*cos(pi*t/t1)*eps1*exp(-30*(x-pulse_loc)^2)/t1;
    otherwise
        areat=0;
end