function c=exitboundary(f)
% EXITBOUNDARY.M - exit boundary: c(t)
% A SHOCK FITTING PRIMER - CHAPTER 4, "Piston Driven Flows".
% exit boundary routine, f=time.
%
% Copyright 2005-2008 M.D.Salas.

global INIT sg shift

switch (INIT)
    case 1
        c0=.05;
        c=c0+sg*f;
    case {2, 3, 5, 6, 7, 8, 8.5, 9, 9.5, 10, 11}
        c=1;
    case 4
        c=1-f^3;
    case {12, 19, 20, 21, 22, 23, 24, 25, 26}
        c=2;
    case 13
        if f > 2
            c=1;
        else
            c=2-(1-cos(pi*f/2))/2;
        end
    case 14
        if f > 2
            c=4;
        else
            c=5-(1-cos(pi*f/2))/2;
        end
    case {15, 16}
        if f > 2+shift
            c=4;
        elseif f > shift
            c=5-(1-cos(pi*(f-shift)/2))/2;
        else
            c=5;
        end
    case {17, 18}
        c=4.5;
    case 27
        c=6;
    case 28
        c=3;
end