function ct=exitboundaryt(f)
%EXITBOUNDARYT EXITBOUNDARY.M - exit boundary: ct(t)
% A SHOCK FITTING PRIMER - CHAPTER 4, "Piston Driven Flows".
% exit boundary routine, first derivative, f=time.
%
% Copyright 2005-2008 M.D.Salas.

global INIT sg shift

switch (INIT)
    case 1
        ct=sg;
    case 4
        ct=-3*f^2;
    case {13, 14}
        if f > 2
            ct=0;
        else
            ct=-pi*sin(pi*f/2)/4;
        end
    case {15, 16}
        if (f > 2+shift) || (f < shift)
            ct=0;
        else
            ct=-pi*sin(pi*(f-shift)/2)/4;
        end
    otherwise
        ct=0;
end
