function ctt=exitboundarytt(f)
%EXITBOUNDARYTT EXITBOUNDARY.M - exit boundary: ctt(t)
% A SHOCK FITTING PRIMER - CHAPTER 4, "Piston Driven Flows".
% exit boundary routine, second time derivative, f=time.
%
% Copyright 2005-2008 M.D.Salas.

global INIT shift

switch (INIT)
    case 4
        ctt=-6*f;
    case {13, 14}
        if f > 2
            ctt=0;
        else
            ctt=-pi^2*cos(pi*f/2)/16;
        end
    case {15, 16}
        if (f > 2+shift) || (f < shift)
            ctt=0;
        else
            ctt=-pi^2*cos(pi*(f-shift)/2)/16;
        end
    otherwise
        ctt=0;
end
