function find_wall_xing
% FIND_wall_XING.M - detects shock reflecting from walll and resets dt
% A SHOCK FITTING PRIMER - CHAPTER 4, "Piston Driven Flows".
%
% Copyright 2005-2008 M.D.Salas.

global eps0 dt WALL kmax x_s w t shock_type 

WALL(1)=0;                                                                  % triggers for shock crossing wall
WALL(2)=0;
b=pistonlaw(t);
bt=pistonlawt(t);
c=exitboundary(t);
ct=exitboundaryt(t);
wICROSS(1)=1/eps0;
wICROSS(2)=1/eps0;

if (shock_type(1) == 'r')                                                   % checks for shock reflection
    if (bt > w(1))                                                          % no crossing if bt < w(1)
        etest=(b-x_s(1))/(w(1)-bt)/dt;                                      % etest=(t*-t)/dt, number of dt's to crossing
        if (etest > 0) && (etest <= 1.1)
            wICROSS(1)=min([etest, 1]);                                     % set trigger on
            WALL(1)=1;
        end
    end
end

if (shock_type(kmax) == 'l') || (shock_type(kmax) == 'c')                   % checks for shock reflection & contact exiting right end
    if (w(kmax) > ct)                                                       % no crossing if w(kmax) < ct
        etest=(c-x_s(kmax))/(w(kmax)-ct)/dt;                                % etest=(t*-t)/dt, number of dt's to crossing
        if (etest > 0) && (etest <= 1.1)
            wICROSS(2)=min([etest, 1]);                                     % set trigger on
            WALL(2)=1;
        end
    end
end

if (WALL(1) == 1) || (WALL(2) == 1)
    [newdt, wkcross]=min(wICROSS);                                          % of all possible crossings, in next t interval, choose the one occuring first
    dt=newdt*dt;                                                            % reset dt
end


