function b=pistonlaw(f)
% PISTONLAW.M - describes piston motion: b(t)
% A SHOCK FITTING PRIMER - CHAPTER 4, "Piston Driven Flows".
% Piston motion routine, f=time
%
% Copyright 2005-2008 M.D.Salas.
%
global INIT sg

switch (INIT)
    case 1
        b=f^3;
    case 4
        b0=.05;
        b=1-b0-sg*f;
    case {12, 14, 15, 16}
        b=(1-cos(pi*f/2))/2;
        if f > 2
            b=1;
        end
    otherwise
        b=0;
end