function bt=pistonlawt(f)
% PISTONLAWT.M - describes piston motion: bt(t)
% A SHOCK FITTING PRIMER - CHAPTER 4, "Piston Driven Flows".
% Piston motion routine, first derivative, f=time
%
% Copyright 2005-2008 M.D.Salas.
%
global INIT sg

switch (INIT)
    case 1
        bt=3*f^2;
    case 4
        bt=-sg;
    case {12, 14, 15, 16}
        bt=pi*sin(pi*f/2)/4;
        if f > 2
            bt=0;
        end
    otherwise
        bt=0;
end