function plot_f1(F,FL,FR,Fexact,f,str,ns)
% PLOT_F.M creates plots
% A SHOCK FITTING PRIMER - CHAPTER 4, "Piston Driven Flows".
% F is function to be plotted, FL, FR are values of F on left and right of
% shock; Fexact is the exact value of F, f is title used on plot, xbar
% corresponds to first signal
%
% Copyright 2005-2008 M.D.Salas.

global nfig x kmax x_s N IS INIT NT t 

c=exitboundary(t);

nfig=nfig+1;                                                       
figure(nfig)
nn=0;

for n=1:N
    nn=nn+1;
    xplot(nn)=x(n);
    uplot(nn)=F(n);
    if kmax > 0
        for k=1:kmax
            if (x(n)-x_s(k))*(x(n+1)-x_s(k)) < 0
                nn=nn+1;
                xplot(nn)=x_s(k);
                uplot(nn)=FL(k);
                nn=nn+1;
                xplot(nn)=x_s(k);
                uplot(nn)=FR(k);
                plot(x_s(k),FL(k),'b+',x_s(k),FR(k),'r+')
                hold on
            end
        end
    end
end

if (kmax > 0) && (N == IS(kmax))
    nn=nn+1;
    xplot(nn)=x_s(k);
    uplot(nn)=FL(k);
    nn=nn+1;
    xplot(nn)=x_s(k);
    uplot(nn)=FR(k);
    plot(x_s(k),FL(k),'b+',x_s(k),FR(k),'r+')
    hold on
end

xplot(nn+1)=c;
uplot(nn+1)=F(NT);
if (kmax == 0) && (INIT == 1)
    plot(xplot,uplot,'k-',x,Fexact,'ko')
elseif INIT == 1
    plot(xplot,uplot,'k-')
else
    plot(xplot,uplot,'k-')
end
    plot(x(ns),F(ns),'ko')
xlabel('x')
ylabel(str)
title(f)
grid on
hold off