% FFT_SAMPLE
% test case for using the MATLAB fft function
% adapted from MATLAB documentation
% test function corresponds to two sine waves with frequencies f_0 & f_1
% plus noise

clear all
global nfig

nfig=0;

f_0=50;                                                                     % test function frequencies
f_1=120;

Fs = 8000;                                                                  % Sampling frequency
dT = 1/Fs;                                                                  % Sample time 
L = 8000;                                                                   % number of samples
start_time=40;
end_time=70;
time_interval=end_time-start_time;                                          % total time for data collection
for n=1:L
    t(n)=start_time+time_interval*(n-1)*dT;                                 % time for data sampling                                              
    % Sum of an f_0 Hz sinusoid and an f_1 Hz sinusoid
    y0(n) = 0.7*sin(2*pi*f_0*t(n)) + sin(2*pi*f_1*t(n));
    y(n) = y0(n) + 2*randn(size(t(n)));                                     % Sinusoids plus noise
end

nfig=nfig+1;
figure(nfig)
plot(t,y)
title('Signal Corrupted with Zero-Mean Random Noise')
xlabel('time (milliseconds)')

freq(L, Fs, time_interval, y)



