function freq(L, Fs, ttotal, data)

global nfig

NFFT = 2^nextpow2(L);                                                       % Next power of 2 from length of y
Y = fft(data,NFFT)/L;
f = Fs/2*linspace(0,1,NFFT/2)/ttotal;                                       % normalize freq by total time

nfig=nfig+1;
figure(nfig)
Amp=2*abs(Y(1:NFFT/2));
Amp(1)=0;

[A1,n1]=max(Amp);
f1=f(n1);
disp([ 'dominant frequency from fft, f1= ' num2str(f1) ])

plot(f,Amp,'b-', f1,A1,'ro')
title('Single-Sided Amplitude Spectrum')
xlabel('Frequency (Hz)')
ylabel('|Y(f)|')
