function freq(L, Fs, ttotal, data)

global nfig

NFFT = 2^nextpow2(L);                                                       % Next power of 2 from length of y
Y = fft(data,NFFT)/L;
f = Fs/2*linspace(0,1,NFFT/2)/ttotal;                                       % normalize freq by total time
                                                                            % g = linspace(a,b,n) generates a row vector g of n points 
                                                                            % linearly spaced between and including a and b.
nfig=nfig+1;
figure(nfig)
Amp=2*abs(Y(1:NFFT/2));
Amp(1)=0;

[A1,n1]=max(Amp);
f1=f(n1);
disp([ 'dominant frequency from fft, f1= ' num2str(f1) ])

switch nfig
    case 7
        amax=10^-1;
        A4=[.000001, amax];
        f4=[.21156, .21156];                                                % frequency from time domain
    case 8
        amax=10^-1;
        A4=[.000001, amax];
        f4=[.21156, .21156];                                                % frequency from time domain
    case 9
        amax=10^-1;
        A4=[.000001, amax];
        f4=[.21209, .21209];                                                % freqnency from time domain
end
A2=[.000001, amax];
f2=[.34606, .34606];                                                        % frequency of signals bouncing between sonic lines, x=1 & x=2
A3=[.000001, amax];
f3=[.1777, .1777];                                                          % frequency of signals bouncing between x=0 and x=1


semilogy(f,Amp,'b-', f2, A2,'k--', f3, A3,'r--', f4, A4,'g--')
xlim([0 5])
ylim([10^-5 10^-1])
switch nfig
    case 7
        title('Shock High Pressure Signal')
    case 8
        title ('Shock Low Pressure Signal')
    case 9
        title ('Shock Wave Path Oscillations')
end
xlabel('Frequency (Hz)')
ylabel('Abs(Amplitude)')
