function blunt_geom(jj,theta)
%
% defines body geometry
% Copyright (c) 2005 - 2009 by M.D.Salas

global y costhe sinthe b bpr RB ell mc x0 angle le supcir

if le == 1
    %
    %  geometry for ellipsoid of revolution or elliptical cylinder
    %  ell=1 for sphere/circle
    %  x0 is a displacement of the origin along x-axis
    %
    ell2=ell^2;
    tane=tan(angle);
    xbar=-(x0+tane/ell/sqrt(ell2+tane^2));
    ybar=ell/sqrt(ell2+tane^2);
    aa=ybar-xbar*tane;
    thebar=pi/2.;
    if xbar ~= 0.0
        thebar=-atan(ybar/xbar);
    end
    if thebar < 0.
        thebar=pi+thebar;
    end
    %
    if jj == 0
        for m=1:mc
            if (angle < 0.) || (y(m) <= thebar)
                b(m)=(-ell2*x0*costhe(m)+sqrt((1.-ell2*x0^2)*sinthe(m)^2+...
                    ell2*costhe(m)^2))/(ell2*costhe(m)^2+sinthe(m)^2);
                bpr(m)=b(m)^2*sinthe(m)*(ell2*x0+(ell2-1.)*b(m)*costhe(m))/(1.-...
                    ell2*x0*(x0+b(m)*costhe(m)));
            else % y(m) > thebar
                b(m)=aa/(sinthe(m)-tane*costhe(m));
                bpr(m)=-b(m)^2/aa*(costhe(m)+tane*sinthe(m));
            end
            bpr(2)=0.;
        end
    else
        sinthes=sin(pi-theta);
        costhes=cos(pi-theta);
        if (angle < 0.) || (theta <= thebar)
            RB=1./sqrt(sinthes^2+ell2*costhes^2);
        else % theta > thebar
            RB=aa/(sinthes-tane*costhes);
        end
    end
    
elseif le == 2
    %
    %     geometry for parabola/paraboloid
    %     (r,theta) origin at x=2+x0
    %     x=.5*y^2, y=rcos(the), x=rcos(the)-(2+x0)
    %
    if jj == 0
        dam=4.+2.*x0;
        for m=1:mc
            if m ~= 2
                b(m)=(costhe(m)+sqrt(costhe(m)^2+dam*sinthe(m)^2))/sinthe(m)^2;
            else
                b(2)=2.+x0;
            end
            dum=costhe(m)-b(m)*sinthe(m)^2;
            bpr(m)=b(m)*sinthe(m)*(1.+b(m)*costhe(m))/dum;
        end
    else
        thes=pi-theta;
        costhes=cos(thes);
        sinthes=sin(thes);
        RB=(costhes+sqrt(costhes^2+4*sinthes^2))/sinthes^2;
    end
elseif le == 3
    %
    %     geometry for super-circle/super-sphere
    %
    if jj == 0
        for m=1:mc
            b(m)=1/(abs(costhe(m))^supcir+abs(sinthe(m))^supcir)^(1/supcir);
            bpr(m)=-costhe(m)*sinthe(m)*(abs(sinthe(m))^(supcir-2)-...
                abs(costhe(m))^(supcir-2))*b(m)^(1+supcir);
        end
    else
        thes=pi-theta;
        costhes=cos(thes);
        sinthes=sin(thes);
        RB=1/(abs(costhes)^supcir+abs(sinthes)^supcir)^(1/supcir);
    end
end
