function blunt_mac_1
% this function computes all points
% original shock-fitting method based on bicharacteristic reaching shock
%
% Copyright (c) 2005 - 2009 by M.D.Salas
%
global z costhe sinthe b c d w wn bpr sigma u v s p dt nc ncm mc mcm
global un vn sn pn ben1 ben2 t cosin ma ld u0 gamma ga gd ge ddy ddz
global sthest1 loop 
%
for loop=0:1
    
    sigthe
    
    for m=2:mc
        an=bpr(m)-sigma(m);
        ab=1./d(m);
        mm1=m-loop;
        if m == mc
            mm1=m-1;
        end
        mp1=mm1+1;
        %
        for n=2:nc
            nm1=n-loop;
            if n == nc
                nm1=ncm;
            end
            np1=nm1+1;
            %
            ad=-1/(b(m)+d(m)*z(n));
            aa=v(n,m)*ad;
            ah=-u(n,m)*ad;
            if (ld == 2) && (m ~= 2)
                ah=2*ah-aa*cosin(m);
            end
            aj=ad*t(n,m);
            %
            if n ~= 2
                pz=(p(np1,m)-p(nm1,m))*ddz;
                uz=(u(np1,m)-u(nm1,m))*ddz;
                vz=(v(np1,m)-v(nm1,m))*ddz;
            else
                uz=(2*u(3,m)-1.5*u(2,m)-.5*u(4,m))*ddz;
                vz=(2*v(3,m)-1.5*v(2,m)-.5*v(4,m))*ddz;
            end
            vy=(v(n,mp1)-v(n,mm1))*ddy;
            uy=(u(n,mp1)-u(n,mm1))*ddy;
            py=(p(n,mp1)-p(n,mm1))*ddy;
            if m == 2
                py=0.;
                sy=0.;
                uy=0.;
                vy=(2*v(n,3)-.5*v(n,4))*ddy;
                if ld == 2
                    ah=-ad*(2*u(n,2)-vy);
                end
            end
            %
            if n == 2
                %
                %   body point calculation
                %
                en1=ben1(m);
                en2=ben2(m);
                uwz=uz*en1+vz*en2;
                vwy=uy*en2-vy*en1;
                vwt=-aa*vwy+aj*en1*py;
                vt=-vwt*en1;
                pt=-(aa*py+gamma*(ad*vy+ab*uwz/en1+ah));
                % entropy upwind
                if aa > 0
                    sy=(s(n,m)-s(n,m-1))*ddy;
                elseif (m ~= mc)
                    sy=(s(n,m+1)-s(n,m))*ddy;
                end
                st=-aa*sy;
                if loop ~= 1
                    pn(2,m)=p(2,m)+pt*dt;
                    vn(2,m)=v(2,m)+vt*dt;
                    sn(2,m)=s(2,m)+st*dt;
                else
                    vn(2,m)=.5*(vn(2,m)+v(2,m)+vt*dt);
                    pn(2,m)=.5*(pn(2,m)+p(2,m)+pt*dt);
                    sn(2,m)=.5*(sn(2,m)+s(2,m)+st*dt);
                end
                un(2,m)=-vn(2,m)*en2/en1;
                if m == 2
                    vn(2,2)=0;
                    un(2,2)=0;
                end
            end % end body calculation
            %
            %   shock point calculation
            %
            if n == nc
                sthes=sigma(m)/c(m);
                sw=sthes*w(m);
                sqr=sqrt(1.+sthes^2);
                en1=-1./sqr;
                en2=-sthes*en1;
                a2=gamma*t(nc,m);
                a=sqrt(a2);
                sthest=sthest1(m);
                en2t=sthest/sqr^3;
                en2te=-en2t*sqr;
                vninr0=u0*(en1*costhe(m)-en2*sinthe(m));
                vw=-u0*(en2*costhe(m)+en1*sinthe(m));
                vninr=vninr0-w(m)*en1;
                vnir0t=(w(m)*en2+vw)*en2te;
                vninr2=vninr^2;
                f=(gd-gamma/vninr2)/ge;
                g=2*vninr/(vninr2-gd);
                dum=gamma*f-a*g;
                uw=u(nc,m)*en1+v(nc,m)*en2;
                uwz=uz*en1+vz*en2;
                uwy=uy*en1+vy*en2;
                dom=(sqr*(uw-a)+w(m))*ab;
                term1=dum*vnir0t;
                term3=gamma*(sw+sqr*vw)*en2t;
                term5=gamma*(aa*(uwy+vw)+aj*py*en2);
                term2=dom*(a*pz-gamma*uwz);
                term4=-a*(aa*py+gamma*(ad*vy+ah));
                term6=term2+term4;
                wt=(term1+term3+term5+term6)/(en1*(dum-gamma));
                %{ 
                  % VORTICITY AT THE SHOCK- first order derivatives
                    vort=(v(nc,m)+uy)/c(m)+ab*(vz+sigma(m)*uz);
                    mac2=vninr2/gamma;
                    den=ge*mac2/(gd*mac2+1);
                    if m ~= 2 % limit needed at m=2
                        curvs(m)=-vort*den/(1-den)^2/vw;
                    end
                %} 
                if loop ~= 1
                    wn(m)=w(m)+wt*dt;
                    cn(m)=c(m)+w(m)*dt;
                    en2o(m)=en2;
                    en1o(m)=en1;
                    en2=en2+en2t*dt;
                    en1=en1+sthes*en2t*dt;
                else
                    wn(m)=.5*(wn(m)+w(m)+wt*dt);
                    cn(m)=.5*(cn(m)+c(m)+w(m)*dt);
                    en2=.5*(en2o(m)+en2+en2t*dt);
                    en1=.5*(en1o(m)+en1+sthes*en2t*dt);
                end
                vninr0=u0*(en1*costhe(m)-en2*sinthe(m));
                vninr=vninr0-wn(m)*en1;
                vninr2=vninr^2;
                vw=-u0*(en2*costhe(m)+en1*sinthe(m)); 
                uwn=(gd*vninr2+gamma)/ge/vninr; 
                uwn=uwn+wn(m)*en1;
                pn(nc,m)=log((vninr2-gd)/ge);
                sn(nc,m)=pn(nc,m)+gamma*log(uwn/vninr);               
                un(nc,m)=uwn*en1-vw*en2;
                vn(nc,m)=uwn*en2+vw*en1;
            end % end shock calculation
            %
            if (n > 2) && (n < nc)
                ac=z(n)*an-bpr(m);
                ae=-ab*ac*ad;
                af=ab*(u(n,m)-w(m)*z(n)-ac*aa);
                ai=v(n,m)*aa;
                ak=ab*t(n,m);
                al=ae*t(n,m);
                am=-u(n,m)*aa;
                % entropy upwind
                if aa > 0
                    sy=(s(n,m)-s(n,m-1))*ddy;
                elseif (m ~= mc)
                    sy=(s(n,m+1)-s(n,m))*ddy;
                end
                if af > 0
                    sz=(s(n,m)-s(n-1,m))*ddz;
                elseif (n ~= nc)
                    sz=(s(n+1,m)-s(n,m))*ddz;
                end
                %
                pt=-(af*pz+aa*py+gamma*(ab*uz+ad*vy+ae*vz+ah));
                ut=-(af*uz+aa*uy+ak*pz+ai);
                vt=-(af*vz+aa*vy+aj*py+al*pz+am);
                st=-(af*sz+aa*sy);
                %
                if loop ~= 1
                    pn(n,m)=p(n,m)+pt*dt;
                    sn(n,m)=s(n,m)+st*dt;
                    un(n,m)=u(n,m)+ut*dt;
                    vn(n,m)=v(n,m)+vt*dt;
                else
                    pn(n,m)=.5*(pn(n,m)+p(n,m)+pt*dt);
                    sn(n,m)=.5*(sn(n,m)+s(n,m)+st*dt);
                    un(n,m)=.5*(un(n,m)+u(n,m)+ut*dt);
                    vn(n,m)=.5*(vn(n,m)+v(n,m)+vt*dt);
                end
            end % end (if n > 2) loop
        end % end for n loop
    end % end for m loop
    %
    % symmetry
    %
    for n=2:nc
        sn(n,1)=sn(n,3);
        pn(n,1)=pn(n,3);
        un(n,1)=un(n,3);
        vn(n,2)=0.;
        v(n,2)=0.;
        vn(n,1)=-vn(n,3);
    end
    c(1)=c(3);
    w(1)=w(3);
    cn(1)=cn(3);
    wn(1)=wn(3);
    %
    % entropy at stagnation point
    %
    sn(2,2)=sn(3,2);
    
    cn(mc)=3*(cn(mcm)-cn(ma))+cn(ma-1);
    wn(mc)=3*(wn(mcm)-wn(ma))+wn(ma-1);
    %
    % update
    %
    for m=1:mc
        wo=w(m);
        co=c(m);
        w(m)=wn(m);
        c(m)=cn(m);
        cn(m)=co;
        wn(m)=wo;
        d(m)=c(m)-b(m);
        for n=2:nc
            po=p(n,m);
            uo=u(n,m);
            vo=v(n,m);
            so=s(n,m);
            p(n,m)=pn(n,m);
            u(n,m)=un(n,m);
            v(n,m)=vn(n,m);
            s(n,m)=sn(n,m);
            pn(n,m)=po;
            un(n,m)=uo;
            vn(n,m)=vo;
            sn(n,m)=so;
            t(n,m)=exp(p(n,m)/ga+s(n,m)/gamma);
        end
    end
    
sig
    
end % end for loop

    function sigthe
        global temp mc sigma c w t u v nc loop ddy mcm sthest1 gamma
        temp(2)=0;
        for m=2:mc
            sthes=sigma(m)/c(m);
            sw=sthes*w(m);
            a2=gamma*t(nc,m);
            v2=u(nc,m)^2+v(nc,m)^2;
            if ( m > 2 ) && ( m < mcm )
                if loop == 0
                    wth=-(w(m)-w(m-1))*ddy;
                else
                    wth=-(w(m+1)-w(m))*ddy;
                end
                if v2/a2 > 0.9
                    wth=(2*w(m-1)-1.5*w(m)-.5*w(m-2))*ddy;
                end
                temp(m)=(wth-sw)/c(m);
            elseif m >= mcm
                wth=(2*w(m-3)-9*w(m-2)+18*w(m-1)-11*w(m))*ddy/6;
                temp(m)=(wth-sw)/c(m);
            end
            sthest1(m)=temp(m);
        end
        temp(1)=-temp(3);
    
    for m=3:mcm
        a2=gamma*t(nc,m);
        v2=u(nc,m)^2+v(nc,m)^2;
        if v2/a2 < 1.1
            sthest1(m)=.25*(temp(m-1)+2*temp(m)+temp(m+1));
        end
    end
    sthest1(2)=0;
    
    function sig
        global mcm sigma c t u v nc ddy ma mc gamma loop
        for m=3:mcm
            sigma(m)=(-c(m-2)+6*c(m-1)-3*c(m)-2*c(m+1))*ddy/6;
            a2=gamma*t(nc,m);
            v2=u(nc,m)^2+v(nc,m)^2;
            if (loop == 1) && (v2/a2 < 0.9)
                sigma(m)=-(c(m+1)-c(m-1))*ddy/2;
            end
        end
        sigma(2)=0.;
        sigma(1)=-sigma(3);
        sigma(mc)=3*(sigma(mcm)-sigma(ma))+sigma(ma-1);