function blunt_mac_2
% this function computes all points
% shock speed computed using new method based on R-H jumps and dQ/dt.
%
% Copyright (c) 2005 - 2009 by M.D.Salas
%
global z costhe sinthe b c d w wn bpr sigma u v s p dt nc ncm mc na loop
global un vn sn pn ben1 ben2 t cosin ma ld u0 gamma ga gd ge gf ddy ddz mcm
global sthest1
%
for loop=0:1
    
    sigthe
  
    for m=2:mc
        an=bpr(m)-sigma(m);
        ab=1./d(m);
        mm1=m-loop;
        if m == mc
            mm1=m-1;
        end
        mp1=mm1+1;
        %
        for n=2:nc
            nm1=n-loop;
            np1=nm1+1;
            %
            ad=-1/(b(m)+d(m)*z(n));
            aa=v(n,m)*ad;
            ah=-u(n,m)*ad;
            if (ld == 2) && (m ~= 2)
                ah=2*ah-aa*cosin(m);
            end
            aj=ad*t(n,m);
            %
            if (n ~= 2) && (n ~= nc)
                pz=(p(np1,m)-p(nm1,m))*ddz;
                uz=(u(np1,m)-u(nm1,m))*ddz;
                vz=(v(np1,m)-v(nm1,m))*ddz;
            elseif n == 2
                uz=(2*u(3,m)-1.5*u(2,m)-.5*u(4,m))*ddz;
                vz=(2*v(3,m)-1.5*v(2,m)-.5*v(4,m))*ddz;
            elseif n == nc
                uz=-(2*u(ncm,m)-1.5*u(nc,m)-.5*u(na,m))*ddz;
                vz=-(2*v(ncm,m)-1.5*v(nc,m)-.5*v(na,m))*ddz;
                pz=-(2*p(ncm,m)-1.5*p(nc,m)-.5*p(na,m))*ddz;
                sz=-(2*s(ncm,m)-1.5*s(nc,m)-.5*s(na,m))*ddz;
            end
            vy=(v(n,mp1)-v(n,mm1))*ddy;
            uy=(u(n,mp1)-u(n,mm1))*ddy;
            py=(p(n,mp1)-p(n,mm1))*ddy;
            if m == 2
                py=0.;
                sy=0.;
                uy=0.;
                vy=(2*v(n,3)-.5*v(n,4))*ddy;
                if ld == 2
                    ah=-ad*(2*u(n,2)-vy);
                end
            end
            %
            if n == 2
                %
                %   body point calculation
                %
                en1=ben1(m);
                en2=ben2(m);
                uwz=uz*en1+vz*en2;
                vwy=uy*en2-vy*en1;
                vwt=-aa*vwy+aj*en1*py;
                vt=-vwt*en1;
                pt=-(aa*py+gamma*(ad*vy+ab*uwz/en1+ah));
                % entropy upwind
                if aa > 0
                    sy=(s(n,m)-s(n,m-1))*ddy;
                elseif (m ~= mc)
                    sy=(s(n,m+1)-s(n,m))*ddy;
                end
                st=-aa*sy;
                if loop ~= 1
                    pn(2,m)=p(2,m)+pt*dt;
                    vn(2,m)=v(2,m)+vt*dt;
                    sn(2,m)=s(2,m)+st*dt;
                else
                    vn(2,m)=.5*(vn(2,m)+v(2,m)+vt*dt);
                    pn(2,m)=.5*(pn(2,m)+p(2,m)+pt*dt);
                    sn(2,m)=.5*(sn(2,m)+s(2,m)+st*dt);
                end
                un(2,m)=-vn(2,m)*en2/en1;
                if m == 2
                    vn(2,2)=0;
                    un(2,2)=0;
                end
            end % end body calculation
            %
            if (n > 2)
                ac=z(n)*an-bpr(m);
                ae=-ab*ac*ad;
                af=ab*(u(n,m)-w(m)*z(n)-ac*aa);
                ai=v(n,m)*aa;
                ak=ab*t(n,m);
                al=ae*t(n,m);
                am=-u(n,m)*aa;
                % entropy upwind
                if aa > 0
                    sy=(s(n,m)-s(n,m-1))*ddy;
                elseif (m ~= mc)
                    sy=(s(n,m+1)-s(n,m))*ddy;
                end
                if af > 0
                    sz=(s(n,m)-s(n-1,m))*ddz;
                elseif (n ~= nc)
                    sz=(s(n+1,m)-s(n,m))*ddz;
                end
                %
                pt=-(af*pz+aa*py+gamma*(ab*uz+ad*vy+ae*vz+ah));
                ut=-(af*uz+aa*uy+ak*pz+ai);
                vt=-(af*vz+aa*vy+aj*py+al*pz+am);
                st=-(af*sz+aa*sy);
                %
                if loop ~= 1
                    pn(n,m)=p(n,m)+pt*dt;
                    sn(n,m)=s(n,m)+st*dt;
                    un(n,m)=u(n,m)+ut*dt;
                    vn(n,m)=v(n,m)+vt*dt;
                else
                    pn(n,m)=.5*(pn(n,m)+p(n,m)+pt*dt);
                    sn(n,m)=.5*(sn(n,m)+s(n,m)+st*dt);
                    un(n,m)=.5*(un(n,m)+u(n,m)+ut*dt);
                    vn(n,m)=.5*(vn(n,m)+v(n,m)+vt*dt);
                end                
                %
                %   shock point calculation
                %
                if n == nc
                    sthes=sigma(m)/c(m);                    
                    sqr=sqrt(1.+sthes^2);
                    en1=-1./sqr;
                    en2=-sthes*en1;                    
                    a2=gamma*t(nc,m);                    
                    a=sqrt(a2);
                    sthest=sthest1(m);
                    en2t=sthest/sqr^3;
                    vninr0=u0*(en1*costhe(m)-en2*sinthe(m));
                    vninr=vninr0-w(m)*en1;
                    vninr0t=u0*(sthes*costhe(m)-sinthe(m))*en2t;
                    at=a*(pt/ga+st/gamma)/2;
                    qt=at/gd-(ut*en1+vt*en2+(u(nc,m)+v(nc,m)*sthes)*en2t); 
                    mrel=vninr/gf;
                    mrel2=mrel^2;
                    g2=2*(gamma*mrel2-gd);
                    g3=2*(gd*mrel2+1);
                    g23=g2*g3;
                    g1p=1/mrel2;
                    g2p=4*gamma*mrel;
                    g3p=4*gd*mrel;
                    gprime=((g23*g1p)^(-.5)/gd)*(((g2p*g3+g2*g3p)-...
                        2*g23/mrel)+1)*g1p;
                    wt=((1+ge/gprime)*vninr0t-ge*qt/gprime-...
                        w(m)*sthes*en2t)/en1;
                    
                    if loop ~= 1
                        wn(m)=w(m)+wt*dt;
                        cn(m)=c(m)+w(m)*dt;
                        en2o(m)=en2;
                        en1o(m)=en1;
                        en2=en2+en2t*dt;
                        en1=en1+sthes*en2t*dt;
                    else
                        wn(m)=.5*(wn(m)+w(m)+wt*dt);
                        cn(m)=.5*(cn(m)+c(m)+w(m)*dt);
                        en2=.5*(en2o(m)+en2+en2t*dt);
                        en1=.5*(en1o(m)+en1+sthes*en2t*dt);
                    end
                    %
                    % update shock values
                    %
                    vninr0=u0*(en1*costhe(m)-en2*sinthe(m));
                    vninr=vninr0-wn(m)*en1;
                    vninr2=vninr^2;
                    vw=-u0*(en2*costhe(m)+en1*sinthe(m));
                    uwn=(gd*vninr2+gamma)/ge/vninr; 
                    uwn=uwn+wn(m)*en1;
                    pn(nc,m)=log((vninr2-gd)/ge);
                    sn(nc,m)=pn(nc,m)+gamma*log(uwn/vninr);
                    un(nc,m)=uwn*en1-vw*en2;
                    vn(nc,m)=uwn*en2+vw*en1;
                    
                end % end shock calculation
            end % end of (if n > 2) loop
        end % end for n loop
    end % end for m loop
    %
    % symmetry
    %
    for n=2:nc
        sn(n,1)=sn(n,3);
        pn(n,1)=pn(n,3);
        un(n,1)=un(n,3);
        vn(n,2)=0.;
        v(n,2)=0.;
        vn(n,1)=-vn(n,3);
    end
    c(1)=c(3);
    w(1)=w(3);
    cn(1)=cn(3);
    wn(1)=wn(3);    
    %
    % entropy at stagnation point
    %
    sn(2,2)=sn(3,2);
    %
    cn(mc)=3*(cn(mcm)-cn(ma))+cn(ma-1);
    wn(mc)=3*(wn(mcm)-wn(ma))+wn(ma-1);
    %
    % update
    %
    for m=1:mc
        wo=w(m);
        co=c(m);
        w(m)=wn(m);
        c(m)=cn(m);
        cn(m)=co;
        wn(m)=wo;
        d(m)=c(m)-b(m);
        for n=2:nc
            po=p(n,m);
            uo=u(n,m);
            vo=v(n,m);
            so=s(n,m);
            p(n,m)=pn(n,m);
            u(n,m)=un(n,m);
            v(n,m)=vn(n,m);
            s(n,m)=sn(n,m);
            pn(n,m)=po;
            un(n,m)=uo;
            vn(n,m)=vo;
            sn(n,m)=so;
            t(n,m)=exp(p(n,m)/ga+s(n,m)/gamma);
        end
    end
    %
    
    sig

end % end for loop

function sigthe
global mc sigma c w gamma t u v nc loop mcm sthest1 ddy

sthest=0;
for m=2:mc
    sthes=sigma(m)/c(m);
    sw=sthes*w(m);
    a2=gamma*t(nc,m);
    v2=u(nc,m)^2+v(nc,m)^2;    
    if ( m > 2 ) && ( m < mcm )
        if loop == 0
            sthest=((-w(m-2)+6*w(m-1)-3*w(m)-2*w(m+1))*ddy/6-sw)/c(m);
        else
            if v2/a2 < 0.9
                sthest=(-(w(m+1)-w(m-1))*ddy/2-sw)/c(m);
            else
                sthest=((-w(m-2)+6*w(m-1)-3*w(m)-2*w(m+1))*ddy/6-sw)/c(m);
            end
        end
    elseif m >= mcm
        sthest=((2*w(m-3)-9*w(m-2)+18*w(m-1)-11*w(m))*ddy/6-sw)/c(m);
    end
    sthest1(m)=sthest;
end
sthest1(1)=-sthest1(3);

function sig
global sigma mc mcm c ddy t gamma v u nc loop ma temp ld

for m=3:mcm
    sigma(m)=(-c(m-2)+6*c(m-1)-3*c(m)-2*c(m+1))*ddy/6;
    a2=gamma*t(nc,m);
    v2=u(nc,m)^2+v(nc,m)^2;
    if (loop == 1) && (v2/a2 < 1)
        sigma(m)=-(c(m+1)-c(m-1))*ddy/2;
    end
end

sigma(2)=0.;
sigma(1)=-sigma(3);
sigma(mc)=2*sigma(mcm)-sigma(ma);

if ld == 2
    return
end

for m=3:mcm
    a2=gamma*t(nc,m);
    v2=u(nc,m)^2+v(nc,m)^2;
    temp(m)=sigma(m);
    if (v2/a2 > 0.5)
        temp(m)=(sigma(m-1)+2*sigma(m)+sigma(m+1))/4;
    end
end
for m=3:mcm
    sigma(m)=temp(m);
end
sigma(2)=0;
sigma(1)=-sigma(3);
sigma(mc)=2*sigma(mcm)-sigma(ma);

