% subroutine blunt_plot1.m
% two-dimensional symmetric and axisymmetric blunt body
%
% Boundary Shock-Fitting Method
%
% Copyright (c) 2005 - 2009 by M.D.Salas
%

global y c w sigma nfig mc k  

nfig=0;

nfig=nfig+1;
figure(nfig)
for n=2:nc % plot grid
   for m=2:mc
       rr=z(n)*(c(m)-b(m))+b(m);
       xxx(n-1,m-1)=rr*costhe(m)+x0;
       yyy(n-1,m-1)=rr*sinthe(m);
   end
end
for n=1:nc-1
   for m=1:mc-1
       xx1(m)=xxx(n,m);
       yy1(m)=yyy(n,m);
   end
   plot(xx1,yy1,'k-')
   hold on
end
for m=1:mc-1
   for n=1:nc-1
       xx2(n)=xxx(n,m);
       yy2(n)=yyy(n,m);
   end
   plot(xx2,yy2,'k-')
end
   axis equal
   axis tight
   xlabel('x')
   ylabel('y')
   title('GRID')
hold off

nfig=nfig+1;
figure(nfig)
for m=2:mc
    thep(m-1)=y(m)*180./pi;
    sigma1(m-1)=sigma(m);
    cplot(m-1)=c(m);
    wplot(m-1)=w(m);
end
plot(thep,sigma1,'k-')
xlabel('Y, deg.')
ylabel('sigma')
title('initial shock slope')
grid on

nfig=nfig+1;
figure(nfig)
plot(thep,cplot,'k-')
text(20,-.02, num2str(k));
xlabel('Y, deg.')
ylabel('c')
title('initial shock radius vs theta')
grid on

% release local variables
clear thep cplot sigma1 xx2 yy2 xx1 yy1 xxx yyy wplot


