function [thew,thewp] = corsym_geom1(ic,phi)
%
%     defines the wall angle 'thew' as a
%     function of phi; also defines thewp=d(thew)/d(phi)
%
% Copyright (c) 2005 - 2009 by M.D.Salas;
%

global cax0 cay0 car0 phica tdel2
global talam2 tdelst
%
if ic == 1
    %
    %     truncated delta eq.(115-116)
    %
    thew=atan(tdelst/sin(phi));
    thewp=-sin(thew)*cos(thew)*cos(phi)/sin(phi);
    return
elseif (ic == 2) && (phi > phica)
    %
    %     circular arc corner  eq.(110-111)
    %
    b=2.*(cos(phi)*cax0-sin(phi)*cay0);
    c=cax0^2+cay0^2-car0^2;
    sqr=sqrt(b^2-4.*c);
    tthw=.5*(-b+sqr);
    thew=atan(tthw);
    bp=-2.*(sin(phi)*cax0+cos(phi)*cay0);
    thewp=.5*bp*(b/sqr-1.)/(1.+tthw^2);
    return
elseif (ic == 4) && (phi > phica)
    %
    % omega= -90, circular arc "wing tip"
    %
    b=2.*cos(phi)*cax0;
    c=cax0^2-car0^2;
    sqr=sqrt(b^2-4.*c);
    tthw=.5*(-b+sqr);
    thew=atan(tthw);
    bp=-2.*sin(phi)*cax0;
    thewp=.5*bp*(b/sqr-1.)/(1.+tthw^2);
else
    %
    %     from eq.(49)
    %
    tthw=tdel2/(sin(phi)-talam2*tdel2*cos(phi));
    thew=atan(tthw);
    thewp=-tthw*(cos(phi)+talam2*tdel2*sin(phi))/(sin(phi)...
        -talam2*tdel2*cos(phi))/(1.+tthw^2);
end