function [p2p1,r2r1,s2,q2,alphas2,fail] = corsym_shock(ach,beta2,g)
% finds attached shock for a wedge angle=beta2, mach no.=ach and gamma=g;
% returns 2D flow field
%
% Copyright (c) 2005 -2009 by M.D.Salas
%
fail=0;
if beta2 ~= 0.;
    tana1=tan(beta2);
    sm=ach^2;
    tryme(1)=tan(asin(1./sqrt(sm))*1.1);
    me=1;
    for kip=1:20;
        smn=sm*tryme(me)^2/(1.+tryme(me)^2);
        tana=2.*(smn-1.)/tryme(me)/(2.+(g+1.)*sm-2.*smn);
        err(me)=tana/tana1-1.;
        if abs(err(me)) < 1.e-6;
            break
        end
        if me == 2;
            tryb=tryme(1)-err(1)*(tryme(2)-tryme(1))/(err(2)-err(1));
            tryme(1)=tryme(2);
            tryme(2)=tryb;
            err(1)=err(2);
            %disp(['kip= ' num2str(kip) ', try= ' num2str(tryme(2)) ...
            %', err= ' num2str(err(2))]);
        else
            me=2;
            tryme(2)=tryme(1)*1.1;
        end
    end
    if abs(err(me)) > 1.e-6;
        disp('iteration failed in function corsym_shock(ach,beta2,g)');
        fail=1;
    end
    p2p1=(2.*g*smn-g+1.)/(g+1.);
    r2r1=(g+1.)*smn/((g-1.)*smn+2.);
    s2=log(p2p1)-g*log(r2r1);
    t2t1=p2p1/r2r1;
    smt=sm-smn;
    smn2=((g-1.)*smn+2.)/(2.*g*smn-(g-1.));
    q2=sqrt(smn2*g*t2t1+smt*g);
    alphas2=atan(tryme(me));
else
    p2p1=1.;
    smn=ach^2;
    r2r1=1.;
    s2=0.;
    q2=smn*g;
    alphas2=asin(1./ach);
end


