% sw_addpoints
%
% doubles mesh points in n & m
%
% Copyright (c) 2005 - 2009 by M.D.Salas
%
global h2 na ma nc ncm mc mcm mcp  m gamma ga dx dy
global h cz bz c b x y ch bh sinthe costhe r p s w u v t xx yy po
global uo vo wo pn un vn wn sn yh yhn bn bhn bzn hn cossin
global cn czn yz yzn bzz bhz bzzn bhzn chz chzn

%
mcnew=2*mc-2;
ncnew=2*nc-1;
manew=mcnew-2;
nanew=ncnew-1;
mcp=mc+1;

for m=1:mcp
    for n=1:nc;
        po(n,m)=x(n);
        uo(n,m)=y(m);
    end
end

dx=1./nanew;
dy=pi/manew;
for m=1:mcnew+1
    for n=1:ncnew
        vo(n,m)=dx*(n-1);
        wo(n,m)=dy*(m-2);
    end
end

pn = griddata(po,uo,p,vo,wo);
un = griddata(po,uo,u,vo,wo);
vn = griddata(po,uo,v,vo,wo);
wn = griddata(po,uo,w,vo,wo);
sn = griddata(po,uo,s,vo,wo);

for m=1:mcnew+1
    yn(m)=dy*(m-2);
end
cn = interp1(y,c,yn);
czn = interp1(y,cz,yn);
yh = interp1(y,yhn,yn);
yz = interp1(y,yzn,yn);
b = interp1(y,bn,yn);
bh = interp1(y,bhn,yn);
bz = interp1(y,bzn,yn);
bzz = interp1(y,bzzn,yn);
bhz = interp1(y,bhzn,yn);
h = interp1(y,hn,yn);

mc=mcnew;
ma=manew;
mcm=mc-1;
mcp=mc+1;
nc=ncnew;
na=nanew;
ncm=na;
for m=1:mcp
    c(m)=cn(m);
    cz(m)=czn(m);
    for n=1:nc
        p(n,m)=pn(n,m);
        u(n,m)=un(n,m);
        v(n,m)=vn(n,m);
        w(n,m)=wn(n,m);
        s(n,m)=sn(n,m);
        t(n,m)=exp(p(n,m)/ga+s(n,m)/gamma);
    end
end

c(1)=c(3);
c(mcp)=c(mcm);
for m=2:mc
    ch(m)=(c(m+1)-c(m-1))/dy;
end

for n=1:nc
    x(n)=dx*(n-1);
end

for m=1:mcp
    y(m)=dy*(m-2);
    costhe(m)=sin(y(m));
    sinthe(m)=-cos(y(m));
    cossin(m)=costhe(m)^2-sinthe(m)^2;
    if (m > 2) && (m < mc)
        chz(m)=.5*(cz(m+1)-cz(m-1))/dy;
        chzn(m)=chz(m);
    end
    for n=1:nc
        r(n,m)=b(m)+x(n)*(c(m)-b(m));
        yy(n,m)=(r(n,m)-h2/r(n,m))*sinthe(m);
        xx(n,m)=(r(n,m)+h2/r(n,m))*costhe(m);
    end
end

ch(2)=0.;
ch(mc)=0.;
c(1)=c(3);
cz(1)=cz(3);
c(mcp)=c(mcm);
cz(mcp)=cz(mcm);
ch(mcp)=-ch(mcm);
ch(1)=-ch(3);
chz(2)=0.;
chz(mc)=0.;
chz(1)=-chz(3);
chz(mcp)=-chz(mcm);
chzn(2)=0.;
chzn(mc)=0.;
chzn(1)=-chzn(3);
chzn(mcp)=-chzn(mcm);
