% sw_body
%
%
% Copyright (c) 2005 - 2009 by M.D.Salas
%
global h2z loop hst dx dy dz hh mc m gamma ga gb
global bz c b bh sinthe costhe r p s w u v t po
global uo vo so pn un vn wn sn yh cossin yz bzz h2zz
%
%     body points are computed here
%
n=1;
nm1=1;
np1=2;
for m=2:mc
    mm1=m-loop;
    mp1=mm1+1;
    %
    py=(p(n,mp1)-p(n,mm1))/dy;
    uy=(u(n,mp1)-u(n,mm1))/dy;
    vy=(v(n,mp1)-v(n,mm1))/dy;
    wy=(w(n,mp1)-w(n,mm1))/dy;
    if loop == 0
        px=(p(2,m)-p(1,m))/dx;
        ux=(u(2,m)-u(1,m))/dx;
        vx=(v(2,m)-v(1,m))/dx;
        wx=(w(2,m)-w(1,m))/dx;
        sx=(s(2,m)-s(1,m))/dx;
    else
        px=.5*(4.*p(2,m)-3.*p(1,m)-p(3,m))/dx;
        ux=.5*(4.*u(2,m)-3.*u(1,m)-u(3,m))/dx;
        vx=.5*(4.*v(2,m)-3.*v(1,m)-v(3,m))/dx;
        wx=.5*(4.*w(2,m)-3.*w(1,m)-w(3,m))/dx;
        sx=.5*(4.*s(2,m)-3.*s(1,m)-s(3,m))/dx;
    end
    %
    % mappings, first derivatives
    %
    r(n,m)=b(m);
    xr=1./(c(m)-b(m));
    xz=-xr*bz(m);
    xh=-xr*bh(m);
    h2or2=(hh/b(m))^2;
    xxr=(1.-h2or2)*costhe(m);
    yyr=(1.+h2or2)*sinthe(m);
    del=1.+(h2or2-2.*cossin(m))*h2or2;
    dum=h2z/b(m);
    xxz=dum*costhe(m);
    yyz=-dum*sinthe(m);
    rx=xxr/del;
    ry=yyr/del;
    hx=-ry/b(m);
    hy=rx/b(m);
    rz=-(ry*yyz+rx*xxz);
    hz=-(hy*yyz+hx*xxz);
    %
    tau=u(n,m)/w(n,m);
    sig=v(n,m)/w(n,m);
    tow=t(n,m)/w(n,m);
    ad=w(n,m)^2-gamma*t(n,m);
    wod=w(n,m)/ad;
    dum=gamma*wod;
    dam=gamma*t(n,m)/ad;
    bl=(hx*u(n,m)+hy*v(n,m))/ad;
    ba=hz+bl*w(n,m);
    bb=hz+hx*tau+hy*sig;
    bg=yh(m)*hx;
    bc=yh(m)*hy;
    %
    al=(rx*u(n,m)+ry*v(n,m))/ad;
    aa=rz+al*w(n,m);
    ab=rz+rx*tau+ry*sig;
    ac=-bc*dam;
    ae=xz+xr*aa+xh*ba;
    % af=xz+xr*ab+xh*bb=0;
    ag=xr*rx+xh*hx;
    ah=xr*ry+xh*hy;
    ai=yz(m)+bb;
    ak=ah*tow;
    am=-bg*dam;
    an=bg*dum;
    ao=yz(m)+ba;
    ap=ag*tow;
    aq=bc*tow;
    ar=dum*bc;
    as=-gamma*bl;
    at=bg*tow;
    au=ag*dum;
    av=ah*dum;
    aw=-gamma*(xr*al+xh*bl);
    ax=-ag*dam;
    ay=-ah*dam;
    az=-t(n,m)*bl;
    aj=-t(n,m)*(xr*al+xh*bl);
    %
    % upwind differences for entropy
    %
    sy=(s(n,m)-s(n,m-1))/dy;
    if ai < 0
        sy=(s(n,m+1)-s(n,m-1))/dy;
    end
    uz=-(ap*px+at*py+ai*uy);
    vz=-(ak*px+aq*py+ai*vy);
    wz=-(aj*px+ay*vx+ae*wx+az*py+am*uy+ac*vy+ao*wy);
    sz=-ai*sy;
    %
    % mappings, second derivatives
    %
    xxh=-b(m)*yyr;
    yyh=b(m)*xxr;
    xxrr=2.*(hh/b(m))^2*costhe(m)/b(m);
    yyrr=-2.*(hh/b(m))^2*sinthe(m)/b(m);
    yyrh=(1.+h2or2)*costhe(m);
    xxrh=-(1.-h2or2)*sinthe(m);
    xxrz=-h2z*costhe(m)/b(m)^2;
    yyrz=h2z*sinthe(m)/b(m)^2;
    xxhh=-b(m)*yyrh;
    yyhh=b(m)*xxrh;
    xxhz=-b(m)*yyrz;
    yyhz=b(m)*xxrz;
    xxzz=h2zz*costhe(m)/b(m);
    yyzz=-h2zz*sinthe(m)/b(m);
    delr=2.*(xxr*xxrr+yyr*yyrr);
    delz=2.*(xxr*xxrz+yyr*yyrz);
    rxr=(xxrr-xxr*delr/del)/del;
    ryr=(yyrr-yyr*delr/del)/del;
    hxr=(-ryr+ry/b(m))/b(m);
    hyr=(rxr-rx/b(m))/b(m);
    rzr=-(ryr*yyz+ry*yyrz+rxr*xxz+rx*xxrz);
    hzr=-(hyr*yyz+hy*yyrz+hxr*xxz+hx*xxrz);
    rxz=(xxrz-xxr*delz/del)/del;
    ryz=(yyrz-yyr*delz/del)/del;
    hxz=-ryz/b(m);
    hyz=rxz/b(m);
    rzz=-(ryz*yyz+ry*yyzz+rxz*xxz+rx*xxzz);
    hzz=-(hyz*yyz+hy*yyzz+hxz*xxz+hx*xxzz);
    %
    taux=(ux-tau*wx)/w(n,m);
    sigx=(vx-sig*wx)/w(n,m);
    r1=-(ao*py+an*uy+ar*vy+as*wy);
    r2=-w(n,m)*(at*py+ai*uy)+u(n,m)*(az*py+am*uy+ac*vy+ao*wy);
    r3=-w(n,m)*(aq*py+ai*vy)+v(n,m)*(az*py+am*uy+ac*vy+ao*wy);
    %
    fx=rx;
    fy=ry;
    fz=rz-bz(m);
    sqr=sqrt(fx^2+fy^2+fz^2);
    vi1=fx/sqr;
    vi2=fy/sqr;
    vi3=fz/sqr;
    vk3=sqrt(vi1^2+vi2^2);
    vj1=-vi2/vk3;
    vj2=vi1/vk3;
    vj3=0.;
    vk1=-vi3*vj2;
    vk2=vi3*vj1;
    %
    fxz=-rxr*xz/xr+rxz;
    fyz=-ryr*xz/xr+ryz;
    fzz=-rzr*xz/xr+rzz-bzz(m);
    
    xlam=-aw*tow-sqrt((aw*tow)^2+dam*((sig*ah+tau*ag)^2+...
        (ah^2+ag^2)));
    rhs2=-(fzz+sig*fyz+tau*fxz);
    rhs1=(xlam-dam*(tau*ag+sig*ah))*r1+ag*gamma*r2/ad+ah*gamma*r3/ad;
    pz=(rhs1-dum*w(n,m)*(xr*rhs2+xlam*(ag*taux+ah*sigx)))/(xlam+...
        ax*tau+ay*sig)-xlam*px;
    
    if loop == 0
        pn(n,m)=p(n,m)+pz*dz;
        sn(n,m)=s(n,m)+sz*dz;
        ucn=u(n,m)+uz*dz;
        vcn=v(n,m)+vz*dz;
    else
        pn(n,m)=.5*(po(n,m)+p(n,m)+pz*dz);
        sn(n,m)=.5*(so(n,m)+s(n,m)+sz*dz);
        ucn=.5*(uo(n,m)+u(n,m)+uz*dz);
        vcn=.5*(vo(n,m)+v(n,m)+vz*dz);
    end
    t(n,m)=exp(pn(n,m)/ga+sn(n,m)/gamma);
    v2=(2.*hst-2.*gb*gamma*t(n,m));
    vwn=ucn*vj1+vcn*vj2;
    wwn=sqrt(v2-vwn^2);
    un(n,m)=vwn*vj1+wwn*vk1;
    vn(n,m)=vwn*vj2+wwn*vk2;
    wn(n,m)=vwn*vj3+wwn*vk3;
end % for m loop

