function sw_cubic

%     sw_cubic(x1,y1,s1,x2,y2,s2,a,b,c,d)
%
%     for y=a+b*x+c*x^2+d*x^3 find a,b,c,d
%
% Copyright (c) 2005 - 2009 by M.D.Salas
%
global ztop1 ytop1 ytopz1 ztop2 ytop2 ytopz2 at1 bt1 ct1 dt1

deltax=ztop1-ztop2;
ddx=1./deltax;
dt1=2.*((ytop2-ytop1)*ddx+.5*(ytopz1+ytopz2))/deltax^2;
ct1=(ytopz1-ytopz2)*.5*ddx-1.5*dt1*(ztop1+ztop2);
bt1=ytopz1-(2.*ct1+3.*dt1*ztop1)*ztop1;
at1=ytop1-(bt1+(ct1+dt1*ztop1)*ztop1)*ztop1;

