% sw_points
%
%
% Copyright (c) 2005 - 2009 by M.D.Salas
%

global dx dy dz hh
global hhn h2 h2zn h2z loop Ivisc nc ncm mc mcm mcp m gamma ga hst
global h cz bz c b x ch bh sinthe costhe r p s w u v t xx yy po
global uo vo wo so pn un vn wn sn yh yhn bn bhn bzn hn cossin
global cn chn czn yz yzn bzz h2zz bhz bzzn h2zzn bhzn co chz czo chzn

%
%     interior points are computed here
%     this routine uses Bernoulli's equation to compute "w"
%
for loop=0:1
    sw_body; % compute body points
    sw_shock; % compute shock points
    for n=2:ncm
        nm1=n-loop;
        np1=nm1+1;
        for m=2:mc
            mm1=m-loop;
            mp1=mm1+1;
            %
            px=(p(np1,m)-p(nm1,m))/dx;
            wx=(w(np1,m)-w(nm1,m))/dx;
            ux=(u(np1,m)-u(nm1,m))/dx;
            vx=(v(np1,m)-v(nm1,m))/dx;
            sx=(s(np1,m)-s(nm1,m))/dx;
            py=(p(n,mp1)-p(n,mm1))/dy;
            uy=(u(n,mp1)-u(n,mm1))/dy;
            vy=(v(n,mp1)-v(n,mm1))/dy;
            wy=(w(n,mp1)-w(n,mm1))/dy;
            sy=(s(n,mp1)-s(n,mm1))/dy;
            %
            % mapping
            %
            r(n,m)=b(m)+(c(m)-b(m))*x(n);
            xr=1./(c(m)-b(m));
            xz=xr*(bz(m)*(x(n)-1.)-cz(m)*x(n));
            xh=-xr*ch(m)*x(n);
            h2or2=(hh/r(n,m))^2;
            xxr=(1.-h2or2)*costhe(m);
            yyr=(1.+h2or2)*sinthe(m);
            del=1.+(h2or2-2.*cossin(m))*h2or2;
            dum=h2z/r(n,m);
            xxz=dum*costhe(m);
            yyz=-dum*sinthe(m);
            rx=xxr/del;
            ry=yyr/del;
            hx=-ry/r(n,m);
            hy=rx/r(n,m);
            rz=-(ry*yyz+rx*xxz);
            hz=-(hy*yyz+hx*xxz);
            %
            uow=u(n,m)/w(n,m);
            vow=v(n,m)/w(n,m);
            tow=t(n,m)/w(n,m);
            ad=w(n,m)^2-gamma*t(n,m);
            wod=w(n,m)/ad;
            dum=gamma*wod;
            dam=gamma*t(n,m)/ad;
            bl=(hx*u(n,m)+hy*v(n,m))/ad;
            ba=hz+bl*w(n,m);
            bb=hz+hx*uow+hy*vow;
            %
            al=(rx*u(n,m)+ry*v(n,m))/ad;
            aa=rz+al*w(n,m);
            ab=rz+rx*uow+ry*vow;
            ac=-hy*dam;
            ae=xz+xr*aa+xh*ba;
            af=xz+xr*ab+xh*bb;
            ag=xr*rx+xh*hx;
            ah=xr*ry+xh*hy;
            ai=yz(m)+bb;
            ak=ah*tow;
            am=-hx*dam;
            an=hx*dum;
            ao=yz(m)+ba;
            ap=ag*tow;
            aq=hy*tow;
            ar=hy*dum;
            as=-gamma*bl;
            at=hx*tow;
            au=ag*dum;
            av=ah*dum;
            aw=-gamma*(xr*al+xh*bl);
            ax=-ag*dam;
            ay=-ah*dam;
            az=-t(n,m)*bl;
            aj=-t(n,m)*(xr*al+xh*bl);
            %
            % upwind differences for entropy
            %
            if abs(af) > 1.e-3;
                sx=(s(n,m)-s(n-1,m))/dx;
                if af < 0;
                    sx=(s(n+1,m)-s(n,m))/dx;
                end
            end
            if abs(ai) > 1.e-3;
                sy=(s(n,m)-s(n,m-1))/dy;
                if ai < 0
                    sy=(s(n,m+1)-s(n,m))/dy;
                end
            end
            
            % For weak shocks (i.e., M=2,
            % cone_angle=5, attack=0)there is a singularity
            % at the shock for px & wx. This can lead to
            % wiggles in p & w. The wiggles can be removed
            % by adding some artificial dissipation.
            % Use with caution.
            coef=10*dx*x(n)^2;
            visc=Ivisc*coef*(p(n+1,m)+p(n-1,m)-2*p(n,m));
            
            uz=-(ap*px+af*ux+at*py+ai*uy);
            vz=-(ak*px+af*vx+aq*py+ai*vy);
            pz=-(ae*px+au*ux+av*vx+aw*wx+ao*py+an*uy+ar*vy+as*wy)+visc;
            sz=-(af*sx+ai*sy);
            %
            if loop == 0;
                pn(n,m)=p(n,m)+pz*dz;
                sn(n,m)=s(n,m)+sz*dz;
                un(n,m)=u(n,m)+uz*dz;
                vn(n,m)=v(n,m)+vz*dz;
                temp=exp(pn(n,m)/ga+sn(n,m)/gamma);
                w2=(2.*hst-2.*gb*gamma*temp)-2*(un(n)^2+vn(n)^2);
                wn(n,m)=sqrt(w2);
            else
                pn(n,m)=.5*(po(n,m)+p(n,m)+pz*dz);
                sn(n,m)=.5*(so(n,m)+s(n,m)+sz*dz);
                un(n,m)=.5*(uo(n,m)+u(n,m)+uz*dz);
                vn(n,m)=.5*(vo(n,m)+v(n,m)+vz*dz);
                temp=exp(pn(n,m)/ga+sn(n,m)/gamma);
                w2=(2.*hst-2.*gb*gamma*temp)-2*(un(n)^2+vn(n)^2);
                wn(n,m)=sqrt(w2);
            end
        end % for n loop
    end % for m loop
    %
    % extrapolation for streamline wetting surface
    % collapse entropy layer
    %
    for m=2:mc
        sn(1,m)=sn(2,m);
    end
    
    for n=1:nc;
        pn(n,1)=pn(n,3);
        un(n,1)=-un(n,3);
        vn(n,1)=vn(n,3);
        wn(n,1)=wn(n,3);
        sn(n,1)=sn(n,3);
        un(n,2)=0.;
        pn(n,mcp)=pn(n,mcm);
        vn(n,mcp)=vn(n,mcm);
        wn(n,mcp)=wn(n,mcm);
        sn(n,mcp)=sn(n,mcm);
        un(n,mcp)=-un(n,mcm);
        un(n,mc)=0.;
        r(n,mcp)=r(n,mcm);
        r(n,1)=r(n,3);
    end
    
    hho=hh;
    hh=hhn;
    h2z=h2zn;
    h2zz=h2zzn;
    for m=1:mcp
        yz(m)=yzn(m);
        h(m)=hn(m);
        b(m)=bn(m);
        co(m)=c(m);
        c(m)=cn(m);
        bh(m)=bhn(m);
        bz(m)=bzn(m);
        bzz(m)=bzzn(m);
        bhz(m)=bhzn(m);
        ch(m)=chn(m);
        czo(m)=cz(m);
        cz(m)=czn(m);
        chz(m)=chzn(m);
        yh(m)=yhn(m);
        for n=1:nc
            % mapping
            r(n,m)=b(m)+x(n)*(c(m)-b(m));
            yy(n,m)=(r(n,m)-h2/r(n,m))*sinthe(m);
            xx(n,m)=(r(n,m)+h2/r(n,m))*costhe(m);
            %
            po(n,m)=p(n,m);
            p(n,m)=pn(n,m);
            uo(n,m)=u(n,m);
            u(n,m)=un(n,m);
            vo(n,m)=v(n,m);
            v(n,m)=vn(n,m);
            wo(n,m)=w(n,m);
            w(n,m)=wn(n,m);
            so(n,m)=s(n,m);
            s(n,m)=sn(n,m);
            t(n,m)=exp(p(n,m)/ga+s(n,m)/gamma);
        end
    end
end % for loop

