% sw_scale
% re-scales the solution on a circular cone by a factor of
% zstar/(zstar+zlast).
% provides a way to keep the computing domain small
%
% Copyright (c) 2005 - 2009 by M.D.Salas
%

global cone dx dy h2 nc mc mcm mcp m
global h cz bz c b x y ch bh sinthe costhe r xx yy
global yh yhn bn bhn bzn hn cossin zlast
global yz yzn bzz bhz bzzn bhzn chz chzn

%
zstar=1/tan(cone);
for m=2:mc
    c(m)=c(m)*zstar/(zlast+zstar);
end

c(1)=c(3);
c(mcp)=c(mcm);
for m=2:mc
    ch(m)=(c(m+1)-c(m-1))/dy;
end

ch(2)=0.;
ch(mc)=0.;
c(1)=c(3);
cz(1)=cz(3);
c(mcp)=c(mcm);
cz(mcp)=cz(mcm);
ch(mcp)=-ch(mcm);
ch(1)=-ch(3);

for m=1:mcp
    yh(m)=yhn(m);
    yz(m)=yzn(m);
    b(m)=bn(m);
    bh(m)=bhn(m);
    bz(m)=bzn(m);
    bzz(m)=bzzn(m);
    bhz(m)=bhzn(m);
    if (m > 2) && (m < mc);
        chz(m)=.5*(cz(m+1)-cz(m-1))/dy;
        chzn(m)=chz(m);
    end
    h(m)=hn(m);
    costhe(m)=sin(y(m));
    sinthe(m)=-cos(y(m));
    cossin(m)=costhe(m)^2-sinthe(m)^2;
    for n=1:nc
        x(n)=dx*(n-1);
        r(n,m)=b(m)+x(n)*(c(m)-b(m));
        yy(n,m)=(r(n,m)-h2/r(n,m))*sinthe(m);
        xx(n,m)=(r(n,m)+h2/r(n,m))*costhe(m);
    end
end

chz(2)=0.;
chz(mc)=0.;
chz(1)=-chz(3);
chz(mcp)=-chz(mcm);
chzn(2)=0.;
chzn(mc)=0.;
chzn(1)=-chzn(3);
chzn(mcp)=-chzn(mcm);