% sw_shock
%
%
% Copyright (c) 2005 - 2009 by M.D.Salas
%
global hhn h2zn h2z loop vin dx dy dz hh vl2 vl3
global cz c b ch sinthe costhe r p w u v t cn chn czn yz h2zz co chz czo
global pn un vn wn sn yh yhn cossin nc mc mcm mcp  m gamma gc gd ge gf chzn
%
%     shock points are computed here
%

n=nc;
nm1=nc-1;
np1=nm1+1;

for m=2:mc
    mm1=m-loop;
    mp1=mm1+1;
    
    py=(p(n,mp1)-p(n,mm1))/dy;
    uy=(u(n,mp1)-u(n,mm1))/dy;
    vy=(v(n,mp1)-v(n,mm1))/dy;
    wy=(w(n,mp1)-w(n,mm1))/dy;
    
    n1=nc;
    n2=nc-1;
    n3=nc-2;
    n4=nc-3;
    if loop == 0
        px=(p(n1,m)-p(n2,m))/dx;
        ux=(u(n1,m)-u(n2,m))/dx;
        vx=(v(n1,m)-v(n2,m))/dx;
        wx=(w(n1,m)-w(n2,m))/dx;
    else
        px=-.5*(4.*p(n2,m)-3.*p(n1,m)-p(n3,m))/dx;
        ux=-.5*(4.*u(n2,m)-3.*u(n1,m)-u(n3,m))/dx;
        vx=-.5*(4.*v(n2,m)-3.*v(n1,m)-v(n3,m))/dx;
        wx=-.5*(4.*w(n2,m)-3.*w(n1,m)-w(n3,m))/dx;
    end
    %
    % mappings, first derivatives
    %
    r(n,m)=c(m);
    xr=1./(c(m)-b(m));
    xz=-cz(m)*xr;
    xh=-ch(m)*xr;
    h2or2=(hh/c(m))^2;
    xxr=(1.-h2or2)*costhe(m);
    yyr=(1.+h2or2)*sinthe(m);
    del=1.+(h2or2-2.*cossin(m))*h2or2;
    dum=h2z/c(m);
    xxz=dum*costhe(m);
    yyz=-dum*sinthe(m);
    rx=xxr/del;
    ry=yyr/del;
    hx=-ry/c(m);
    hy=rx/c(m);
    rz=-(ry*yyz+rx*xxz);
    hz=-(hy*yyz+hx*xxz);
    %
    tau=u(n,m)/w(n,m);
    sig=v(n,m)/w(n,m);
    tow=t(n,m)/w(n,m);
    ad=w(n,m)^2-gamma*t(n,m);
    wod=w(n,m)/ad;
    dum=gamma*wod;
    dam=gamma*t(n,m)/ad;
    bl=(hx*u(n,m)+hy*v(n,m))/ad;
    ba=hz+bl*w(n,m);
    bb=hz+hx*tau+hy*sig;
    bg=yh(m)*hx;
    bc=yh(m)*hy;
    %
    al=(rx*u(n,m)+ry*v(n,m))/ad;
    aa=rz+al*w(n,m);
    ab=rz+rx*tau+ry*sig;
    ac=-bc*dam;
    ae=xz+xr*aa+xh*ba;
    af=xz+xr*ab+xh*bb;
    ag=xr*rx+xh*hx;
    ah=xr*ry+xh*hy;
    ai=yz(m)+bb;
    ak=ah*tow;
    am=-bg*dam;
    an=bg*dum;
    ao=yz(m)+yh(m)*ba;
    ap=ag*tow;
    aq=bc*tow;
    ar=bc*dum;
    as=-gamma*bl;
    at=bg*tow;
    au=ag*dum;
    av=ah*dum;
    aw=-gamma*(xr*al+xh*bl);
    ax=-ag*dam;
    ay=-ah*dam;
    az=-t(n,m)*bl;
    aj=-t(n,m)*(xr*al+xh*bl);
    %
    % mappings, second derivatives
    %
    xxh=-c(m)*yyr;
    yyh=c(m)*xxr;
    xxrr=2.*(hh/c(m))^2*costhe(m)/c(m);
    yyrr=-2.*(hh/c(m))^2*sinthe(m)/c(m);
    yyrh=(1.+h2or2)*costhe(m);
    xxrh=-(1.-h2or2)*sinthe(m);
    xxrz=-h2z*costhe(m)/c(m)^2;
    yyrz=h2z*sinthe(m)/c(m)^2;
    xxhh=-c(m)*yyrh;
    yyhh=c(m)*xxrh;
    xxhz=-c(m)*yyrz;
    yyhz=c(m)*xxrz;
    xxzz=h2zz*costhe(m)/c(m);
    yyzz=-h2zz*sinthe(m)/c(m);
    delr=2.*(xxr*xxrr+yyr*yyrr);
    delz=2.*(xxr*xxrz+yyr*yyrz);
    rxr=(xxrr-xxr*delr/del)/del;
    ryr=(yyrr-yyr*delr/del)/del;
    hxr=(-ryr+ry/c(m))/c(m);
    hyr=(rxr-rx/c(m))/c(m);
    rzr=-(ryr*yyz+ry*yyrz+rxr*xxz+rx*xxrz);
    hzr=-(hyr*yyz+hy*yyrz+hxr*xxz+hx*xxrz);
    rxz=(xxrz-xxr*delz/del)/del;
    ryz=(yyrz-yyr*delz/del)/del;
    hxz=-ryz/c(m);
    hyz=rxz/c(m);
    rzz=-(ryz*yyz+ry*yyzz+rxz*xxz+rx*xxzz);
    hzz=-(hyz*yyz+hy*yyzz+hxz*xxz+hx*xxzz);
    taux=(ux-tau*wx)/w(n,m);
    sigx=(vx-sig*wx)/w(n,m);
    r1=-(ao*py+an*uy+ar*vy+as*wy);
    r2=-w(n,m)*(at*py+ai*uy)+u(n,m)*(az*py+am*uy+ac*vy+ao*wy);
    r3=-w(n,m)*(aq*py+ai*vy)+v(n,m)*(az*py+am*uy+ac*vy+ao*wy);
    fx=rx-ch(m)*hx;
    fy=ry-ch(m)*hy;
    fz=rz-ch(m)*hz-cz(m);
    sqr=sqrt(fx^2+fy^2+fz^2);
    ci1=fx/sqr;
    ci2=fy/sqr;
    ci3=fz/sqr;
    fxz=-(rxr-ch(m)*hxr)*xz/xr+(rxz-ch(m)*hxz-chz(m)*hx);
    fyz=-(ryr-ch(m)*hyr)*xz/xr+(ryz-ch(m)*hyz-chz(m)*hy);
    fzm=-(rzr-ch(m)*hzr)*xz/xr+(rzz-ch(m)*hzz-chz(m)*hz);
    %
    vninf=vin*(vl2*ci2+vl3*ci3);
    xmn2=vninf^2/gamma;
    xmn=vninf/gf;
    vn2=vninf*(1.+gd*xmn2)/(ge*xmn2);
    cvnz=(gd*xmn2-1.)/(ge*xmn2);
    cpz=4.*gf*xmn/(2.*gamma*xmn2-(gamma-1.));
    c1pz=cpz*vin*(vl2*(fyz-(fy*fx*fxz+fy^2*fyz)/sqr^2)/sqr...
        -vl3*(fz*fx*fxz+fy*fz*fyz)/sqr^3);
    c2pz=cpz*vin*(vl3*(1.-fz^2/sqr^2)/sqr-vl2*fy*fz/sqr^3);
    c1uz=(cvnz-1.)*ci1*c1pz/cpz+(vn2-vninf)*(fxz-(fx^2*fxz+...
        fx*fy*fyz)/sqr^2)/sqr;
    c1vz=(cvnz-1.)*ci2*c1pz/cpz+(vn2-vninf)*(fyz-(fx*fy*fxz+...
        fy^2*fyz)/sqr^2)/sqr;
    c1wz=(cvnz-1.)*ci3*c1pz/cpz-(vn2-vninf)*fz*(fx*fxz+fy*fyz)/sqr^3;
    c2uz=(cvnz-1.)*ci1*c2pz/cpz-(vn2-vninf)*fx*fz/sqr^3;
    c2vz=(cvnz-1.)*ci2*c2pz/cpz-(vn2-vninf)*fy*fz/sqr^3;
    c2wz=(cvnz-1.)*ci3*c2pz/cpz+(vn2-vninf)*(1.-fz^2/sqr^2)/sqr;
    xlam=ae+sqrt(aj*(tau*ax+sig*ay)/tow-(ax*ag+ay*ah));
    xnu1=(ae+tau*ax-xlam)*(ae+sig*ay-xlam)-tau*sig*ay*ax;
    xnu2=(ax*(ae+tau*ax-xlam)+sig*ax*ay)/t(n,m);
    xnu3=(ay*(ae+sig*ay-xlam)+tau*ax*ay)/t(n,m);
    rhs1=r1*xnu1+r2*xnu2+r3*xnu3;
    xnum=rhs1-xnu1*(xlam*px+c1pz)-xnu2*(w(n,m)^2*xlam*taux+...
        w(n,m)*c1uz-u(n,m)*c1wz)-xnu3*(w(n,m)^2*xlam*sigx+...
        w(n,m)*c1vz-v(n,m)*c1wz);
    xnud=xnu1*c2pz+xnu2*(w(n,m)*c2uz-u(n,m)*c2wz)+...
        xnu3*(w(n,m)*c2vz-v(n,m)*c2wz);
    czz=-xnum/xnud+fzm;
    if loop == 0
        czn(m)=cz(m)+czz*dz;
        cn(m)=c(m)+cz(m)*dz;
    else
        czn(m)=.5*(czo(m)+cz(m)+czz*dz);
        cn(m)=.5*(co(m)+c(m)+cz(m)*dz);
    end
end % for m loop

%
for m=3:mcm
    chn(m)=.5*(cn(m+1)-cn(m-1))*yhn(m)/dy;
    chzn(m)=.5*(czn(m+1)-czn(m-1))*yhn(m)/dy;
end
cn(1)=cn(3);
cn(mcp)=cn(mcm);
chn(1)=-chn(3);
chn(mcp)=-chn(mcm);
chzn(1)=-chzn(3);
chzn(mcp)=-chzn(mcm);
czn(1)=czn(3);
czn(mcp)=czn(mcm);
chn(2)=0.;
chn(mc)=0.;
chzn(2)=0.;
chzn(mc)=0.;
for m=2:mc
    h2or2=(hhn/cn(m))^2;
    xxr=(1.-h2or2)*costhe(m);
    yyr=(1.+h2or2)*sinthe(m);
    dum=h2zn/cn(m);
    xxz=dum*costhe(m);
    yyz=-dum*sinthe(m);
    del=xxr^2+yyr^2;
    rx=xxr/del;
    ry=yyr/del;
    hx=-ry/cn(m);
    hy=rx/cn(m);
    rz=-(ry*yyz+rx*xxz);
    hz=-(hy*yyz+hx*xxz);
    fxn=rx-chn(m)*hx;
    fyn=ry-chn(m)*hy;
    fzn=rz-chn(m)*hz-czn(m);
    sqr=sqrt(fxn^2+fyn^2+fzn^2);
    ci1n=fxn/sqr;
    ci2n=fyn/sqr;
    ci3n=fzn/sqr;
    vninf=vin*(vl2*ci2n+vl3*ci3n);
    smnin=vninf^2/gamma;
    vi=vninf*(1.+gd*smnin)/ge/smnin;
    rho=vninf/vi;
    press=(gc*rho-1.)/(gc-rho);
    pn(nc,m)=log(press);
    t(nc,m)=press/rho;
    sn(nc,m)=pn(nc,m)-gamma*log(rho);
    un(nc,m)=vi*ci1n-vninf*ci1n;
    vn(nc,m)=vi*ci2n-vninf*ci2n+vin*vl2;
    wn(nc,m)=vi*ci3n-vninf*ci3n+vin*vl3;
end

