% guesses shock angle for given Mach and cone angle
% in the range 2 <= Mach < inf
%
% Copyright (c) 2005 - 2009 by M.D.Salas
%

global guess_shk_ang mach body_angle

con=body_angle;
if 0 < con*180/pi < 57
    % curve fit for 0 <= cone < 57 degrees and Mach=inf
    cinf=[0.75769,-0.99415,0.42902,1.0391,-2.0279e-016];
    shkinf=(((cinf(1)*con+cinf(2))*con+cinf(3))*con+cinf(4))*con+cinf(5);
    %
    % curve fit for 0 <= cone <= 40.5 degrees and Mach=2
    if con*180/pi < 40.5
        c2=[9.3785,-12.034,6.1102,-0.65768,0.52381];
        shk2=(((c2(1)*con+c2(2))*con+c2(3))*con+c2(4))*con+c2(5);
        guess_shk_ang=2*shk2/mach-2*shkinf*(1/mach-1/2);
    else
        % valid for 40.5 <= cone < 57 degrees
        ct=[0.24012,0.96959,0.0043086];
        shkt=(ct(1)*con+ct(2))*con+ct(3);
        guess_shk_ang=.5*(shkt+shkinf);
    end
else
    disp('The cone angle is less than zero or greater than 57 degrees')
    disp('guess_shk_ang not defined in sw_shockangle')
end
