% sw_store
%
% Copyright (c) 2005 - 2009 by M.D.Salas
%

global k nfig istore nc mc m gamma cone z cz x p w u v t xx yy
%
mplot=1; % mplot=1 to plot Mach contours on windward and leeward planes
pplot=0; % pplot=1 to plot pressure contours on surface, windward and leeward planes
%
if istore == 0 % store data
    %
    %
    if mplot == 1 % store values on upper/lower symmetry planes for plotting
        ybtplot(k)=yy(1,mc);
        ystplot(k)=yy(nc,mc);
        ybbplot(k)=yy(1,2);
        ysbplot(k)=yy(nc,2);
        czsave(k)=cz(mc);
        zp(k)=z;
        for n=1:nc
            machtop(k,n)=sqrt((u(n,mc)^2+v(n,mc)^2+w(n,mc)^2)/(gamma*t(n,mc)));
            machbot(k,n)=sqrt((u(n,2)^2+v(n,2)^2+w(n,2)^2)/(gamma*t(n,2)));
            zzs(k,n)=z;
            yytop(k,n)=yy(n,mc);
            yybot(k,n)=yy(n,2);
        end
    end
    
    if pplot == 1 % store data to create pressure plots
        mid=mc/2+1;
        zpp(k)=z;
        dsurft(k,1)=0.;
        psurft(k,1)=exp(p(1,mid));
        zpt(k,1)=z;
        for m=mid+1:mc
            mm=m-(mid-1);
            zpt(k,mm)=z;
            psurft(k,mm)=exp(p(1,m));
            dyy=yy(1,m)-yy(1,m-1);
            dxx=xx(1,m)-xx(1,m-1);
            dsurft(k,mm)=dsurft(k,mm-1)+sqrt(dyy^2+dxx^2);
        end
        
        dsurfb(k,1)=0.;
        psurfb(k,1)=exp(p(1,mid));
        zpb(k,1)=z;
        for mm=2:mid-1
            m=(mid+1)-mm;
            zpb(k,mm)=z;
            psurfb(k,mm)=exp(p(1,m));
            dyy=yy(1,m)-yy(1,m+1);
            dxx=xx(1,m)-xx(1,m+1);
            dsurfb(k,mm)=dsurfb(k,mm-1)-sqrt(dyy^2+dxx^2);
        end
        %
        mt=mc-(mid-1);
        dt=dsurft(k,mt);
        for n=2:nc
            zpt(k,mt+n-1)=z;
            psurft(k,mt+n-1)=exp(p(n,mc));
            dsurft(k,mt+n-1)=dt+yy(n,mc)-yy(1,mc);
        end
        %
        mb=mid-1;
        db=dsurfb(k,mb);
        for n=2:nc
            zpb(k,mb+n-1)=z;
            psurfb(k,mb+n-1)=exp(p(n,2));
            dsurfb(k,mb+n-1)=db+yy(n,2)-yy(1,2);
        end
        
        ybtplot(k)=dsurft(k,mc-(mid-1));
        ybbplot(k)=dsurfb(k,(mid-1));
        ystplot(k)=dsurft(k,mt+nc-1);
        ysbplot(k)=dsurfb(k,mb+nc-1);
    end
elseif istore == 1
    if pplot == 1    % plot surface pressure contours
        nfig=nfig+1;
        figure(nfig);
        plot(zpp,ybtplot,'k-',zpp,ybbplot,'k-');
        axis equal;
        title('pressure contours');
        xlabel('z');
        ylabel('y');
        hold on;
        plot(zpp,ystplot,'k-',zpp,ysbplot,'k-')
        [ccont,hcont]=contour(zpt,dsurft,psurft,'k');
        clabel(ccont,hcont);
        [cconb,hconb]=contour(zpb,dsurfb,psurfb,'k');
        clabel(cconb,hconb);
        hold off
    end
    if mplot == 1;% plot Mach contours on leeward plane
        
        zp0=[-1/tan(cone), 0.];
        ybt0=[0.,1];
        ybb0=[0.,-1];
        yst0=[0.,ystplot(1)];
        ysb0=[0.,ysbplot(1)];
        
        if k > 5
            nfig=nfig+1;
            figure(nfig);
            plot(zp,ybtplot,'k-',zp,ystplot,'k-',zp,ybbplot,'k-',zp,ysbplot,'k-',...
                zp0,ybt0,'k-',zp0,ybb0,'k-',zp0,yst0,'k-',zp0,ysb0,'k-');
            axis equal;
            xlabel('z');
            ylabel('y');
            title(['Mach contours, z=', num2str(z) ]);
            hold on
            
            [ccont,hcont]=contour(zzs,yytop,machtop,'k-');
            clabel(ccont,hcont);
            contour(zzs,yytop,machtop,'k-');
            [cconb,hconb]=contour(zzs,yybot,machbot,'k-');
            clabel(cconb,hconb);
            contour(zzs,yybot,machbot,'k-');
            hold off;
        end
        
        nfig=nfig+1;
        figure(nfig);
        for n=1:nc
            mtop(n)=sqrt((u(n,mc)^2+v(n,mc)^2+w(n,mc)^2)/(gamma*t(n,mc)));
            mbot(n)=sqrt((u(n,2)^2+v(n,2)^2+w(n,2)^2)/(gamma*t(n,2)));
        end
        plot(x,mtop,'r-',x,mbot,'bo');
        xlabel('X')
        title('Mach number');
        legend('m=mc','m=2');
        
        nfig=nfig+1;
        figure(nfig);
        plot(zp,czsave,'k-');
        title('shock slope');
        xlabel('z');
        ylabel('cz');
    end
end